/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// MessageType the model 'MessageType'
type MessageType string

// List of MessageType
const (
	TEXT MessageType = "text"
	IMAGE MessageType = "image"
	VIDEO MessageType = "video"
	AUDIO MessageType = "audio"
	DOCUMENT MessageType = "document"
	FILE MessageType = "file"
	STICKER MessageType = "sticker"
	LOCATION MessageType = "location"
	CONTACT MessageType = "contact"
	TEMPLATE MessageType = "template"
	BUTTONS MessageType = "buttons"
	LIST MessageType = "list"
	INFO MessageType = "info"
	ORDER_DETAILS MessageType = "order_details"
	ORDER_STATUS MessageType = "order_status"
	STORY MessageType = "story"
	REQUEST_LOCATION MessageType = "request_location"
	REQUEST_PHONE_NUMBER MessageType = "request_phone_number"
	REMOVE_KEYBOARD MessageType = "remove_keyboard"
	REACTION MessageType = "reaction"
	MEDIA_CAROUSEL MessageType = "media_carousel"
	UNKNOWN_MESSAGE MessageType = "unknown_message"
)

// All allowed values of MessageType enum
var AllowedMessageTypeEnumValues = []MessageType{
	"text",
	"image",
	"video",
	"audio",
	"document",
	"file",
	"sticker",
	"location",
	"contact",
	"template",
	"buttons",
	"list",
	"info",
	"order_details",
	"order_status",
	"story",
	"request_location",
	"request_phone_number",
	"remove_keyboard",
	"reaction",
	"media_carousel",
	"unknown_message",
}

func (v *MessageType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := MessageType(value)
	for _, existing := range AllowedMessageTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid MessageType", value)
}

// NewMessageTypeFromValue returns a pointer to a valid MessageType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewMessageTypeFromValue(v string) (*MessageType, error) {
	ev := MessageType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for MessageType: valid values are %v", v, AllowedMessageTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v MessageType) IsValid() bool {
	for _, existing := range AllowedMessageTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to MessageType value
func (v MessageType) Ptr() *MessageType {
	return &v
}

type NullableMessageType struct {
	value *MessageType
	isSet bool
}

func (v NullableMessageType) Get() *MessageType {
	return v.value
}

func (v *NullableMessageType) Set(val *MessageType) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageType) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageType(val *MessageType) *NullableMessageType {
	return &NullableMessageType{value: val, isSet: true}
}

func (v NullableMessageType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

